#include <stdlib.h>
#include <stdio.h>
#include "dom.h"

int
main(int argc, char *argv[])
{
	DOM_Document *doc, *clone;
	DOM_Element *root;

	if (argc < 2) {
		fprintf(stderr, "Must provide XML filename\n");
		return EXIT_FAILURE;
	}

	doc = DOM_Implementation_createDocument(NULL, NULL, NULL);
	if (DOM_DocumentLS_load(doc, argv[1]) == 0) {
		return EXIT_FAILURE;
	}

	root = doc->u.Document.documentElement;
	clone = DOM_Node_cloneNode(doc, 1);

	if (DOM_DocumentLS_save(doc, "/dev/stdout", NULL) == 0) {
		return EXIT_FAILURE;
	}
	if (DOM_DocumentLS_save(clone, "clone.xml", NULL) == 0) {
		return EXIT_FAILURE;
	}

	DOM_Document_destroyNode(doc, doc);
	DOM_Document_destroyNode(clone, clone);

	return EXIT_SUCCESS;
}
